/*
 * Smart Wistle Counter Kitchen 
 * Date                Change description
 * July 2022           First Creation
 * V4 July 2022
 * Author: Palak Patel (palak.patel03@gmail.com)
 */

#include <Keypad.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>



/////////////////////////////////
// Display related

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
// The pins for I2C are defined by the Wire-library. 
// On an arduino UNO:       A4(SDA), A5(SCL)
// On an arduino MEGA 2560: 20(SDA), 21(SCL)
// On an arduino LEONARDO:   2(SDA),  3(SCL), ...
#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C ///< See datasheet for Address; 0x3D for 128x64, 0x3C for 128x32
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

#define NUMFLAKES     10 // Number of snowflakes in the animation example

#define LOGO_HEIGHT   16
#define LOGO_WIDTH    16
static const unsigned char PROGMEM logo_bmp[] =
{ 0b00000000, 0b11000000,
  0b00000001, 0b11000000,
  0b00000001, 0b11000000,
  0b00000011, 0b11100000,
  0b11110011, 0b11100000,
  0b11111110, 0b11111000,
  0b01111110, 0b11111111,
  0b00110011, 0b10011111,
  0b00011111, 0b11111100,
  0b00001101, 0b01110000,
  0b00011011, 0b10100000,
  0b00111111, 0b11100000,
  0b00111111, 0b11110000,
  0b01111100, 0b11110000,
  0b01110000, 0b01110000,
  0b00000000, 0b00110000 };

////////////////
/// Temperature related

#include <OneWire.h>
#include <DallasTemperature.h>

// Data wire is plugged into digital pin 2 on the Arduino
#define ONE_WIRE_BUS 2

// Setup a oneWire instance to communicate with any OneWire device
OneWire oneWire(ONE_WIRE_BUS);  

// Pass oneWire reference to DallasTemperature library
DallasTemperature sensors(&oneWire);

////////////////////////
//Keboard related
const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns
// Define the Keymap
char hexaKeys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};
byte rowPins[ROWS] = {11, 10, 9, 8}; //connect to the Rows of the keypad pin 8, 7, 6, 5 respectively
byte colPins[COLS] = {7, 6, 5, 4}; //connect to the Columns of the keypad pin 4, 3, 2, 1 respectively

//initialize an instance of class NewKeypad
Keypad customKeypad = Keypad( makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS); 

//////
//Buzzer related

const int buzzer = 53; //buzzer to arduino pin 53


 ////////// constants for pressure coocker whistle detection by mic
 // Whistle counter constantsout
 const int long sound_high_thresold = 200;////   250
 const int long sound_low_thresold = 100;////
 const int no_of_samples=25000;

unsigned long previousMillis = 0;
unsigned long startMillis = 0;;
unsigned int sec_time;
//////////////////////////////////////////
void setup() {
  pinMode(buzzer, OUTPUT); // Set buzzer - pin 9 as an output


  sensors.begin();  // Start up the library

  Serial.begin(9600);
   

  // SSD1306_SWITCHCAPVCC = generate display voltage from 3.3V internally
  if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }

    // Clear the buffer
  display.clearDisplay();
  display.setTextSize(3);             // Normal 1:1 pixel scale
  display.setTextColor(SSD1306_WHITE);        // Draw white text
 

 }

/*ISR(TIMER1_OVF_vect)        // interrupt service routine that wraps a user defined function supplied by attachInterrupt
{
  TCNT1 = 34286;            // preload timer
// tm_flag= not tm_flag;
   display.setCursor(0,0);             // Start at top-left corner
   display.println(F("TMR"));
   //display.print(tm_flag);
   display.display();
 
}

*/
void loop() {
      float ftemp;
      int imic_val, i;
      char customKey; 
      boolean wst_ongoing;
      int no_of_wst_detected;
      int long sum;
      boolean flag1;
      int itotal_wstls; // = 3;////
      unsigned long currentMillis ;
      
       wst_ongoing=false;
      no_of_wst_detected=0;    
     flag1=false;

    digitalWrite(buzzer,LOW);    
    
    
    // Serial.print("WST V3");
    display.setCursor(0,0);             // Start at top-left corner
   display.println(F("WST V4"));
   display.display();
   delay(2000);

  
   //sensors.requestTemperatures(); 
  //ftemp=sensors.getTempCByIndex(0);
   imic_val=analogRead(0);
  display.clearDisplay();
   display.setCursor(0,0);
 // display.print(ftemp);
 // display.print(F("C"));
  display.print(F("SN="));
  display.print(imic_val);
  display.display();

    delay(2000);

  display.clearDisplay();
   display.setCursor(0,0);
  display.print(F("WST N ?"));
  display.display();

   
 while(flag1==false)
 {
   customKey = customKeypad.getKey();
   
   // Serial.println(customKey); // Send the pressed key value to the arduino serial monitor
  
  if (customKey=='1') 
  {
   flag1=true;
  itotal_wstls=1;
  }
  else if (customKey=='2') 
  {
   flag1=true;
  itotal_wstls=2;
  }
  else if (customKey=='3') 
  {
   flag1=true;
  itotal_wstls=3;
  }
else if (customKey=='4') 
  {
   flag1=true;
  itotal_wstls=4;
  }
else if (customKey=='5') 
  {
   flag1=true;
  itotal_wstls=5;
  }
else if (customKey=='6') 
  {
   flag1=true;
  itotal_wstls=6;
  }
else if (customKey=='7') 
  {
   flag1=true;
  itotal_wstls=7;
  }
else if (customKey=='8') 
  {
   flag1=true;
  itotal_wstls=8;
  }
else if (customKey=='9') 
  {
   flag1=true;
  itotal_wstls=9;
  }

 }
   display.clearDisplay();
  display.setCursor(0,0);            
  display.print(itotal_wstls);
  display.display();

   delay(2000);

  display.clearDisplay();
   display.setCursor  (0,0);
  display.print(F("Wait"));
  display.display();

  no_of_wst_detected=0;
 // sec_time=0;  
 startMillis=millis();

   while(no_of_wst_detected < itotal_wstls )
  {
   
    currentMillis = millis();
       
  if (currentMillis - previousMillis >= 1000)
    {
    // save the last time you blinked the LED
     sec_time=(currentMillis - startMillis)/1000;
      previousMillis = currentMillis;
     display.clearDisplay();
     display.setCursor  (0,0);
     display.print(F("W:"));
     display.print(no_of_wst_detected);
     display.print(F(":"));
     display.print(sec_time);
     display.display();
    }
    


     sum=0; 
     for(i=0;i<no_of_samples;i++)
      {
        imic_val=analogRead(0);
        sum=sum+imic_val;
       }
       Serial.println(sum); 
       if ((sum > (sound_high_thresold*no_of_samples)) && wst_ongoing==false)
       {
        no_of_wst_detected++;
        wst_ongoing=true;
       Serial.println("Number of Whistles="); 
       Serial.println(no_of_wst_detected); 
 //        display.clearDisplay();
 //       display.setCursor(0,0);
//       display.print(F("Dtc"));
//       display.print(no_of_wst_detected);
//       display.display();

       delay(2000);         

       }
          
       if ((sum  <  (sound_low_thresold*no_of_samples)) && wst_ongoing==true)
       {
        wst_ongoing=false;
       Serial.println("Whistles low"); 
  
       }
       
     }

      while(wst_ongoing==true )
     {
     sum=0; 
     for(i=0;i<no_of_samples;i++)
      {
        imic_val=analogRead(0);
        sum=sum+imic_val;
       }
       Serial.println(sum); 
 
       if ((sum  <  (sound_low_thresold*no_of_samples)) && wst_ongoing==true)
       {
        wst_ongoing=false;
       Serial.println("All done"); 
       }
     }  
         
         display.clearDisplay();
        display.setCursor(0,0);
       display.println(F("Done!"));
       //display.println(F("Buzzer..")); 
       display.display();

       for(i=1;i<20;i++)
      {
        tone(buzzer, i*200); // Send 1KHz sound signal...
        delay(1000);        // ...for 1 sec
        noTone(buzzer);     // Stop sound...
        delay(100);        // ...for 1sec
      }
 
digitalWrite(buzzer,LOW);    

 while(true)
 {};
 
 
}

 
